/*
hmu.java

Zhangshi Yin

3/27/2002
*/


import java.io.*;
import java.awt.*;
import java.text.*;
import java.lang.*;
import javax.swing.*;
import java.awt.event.*;
import java.lang.String;
import java.awt.Component;
import javax.swing.JFileChooser;
import java.awt.event.MouseEvent;
import java.lang.RuntimeException;
import java.awt.event.MouseListener;
import java.awt.GraphicsConfiguration;
import java.awt.event.MouseMotionListener;
import java.awt.event.ActionListener;


public class hmu extends JFrame implements ActionListener
{
  //Declare method.
  public native void displayhmu(String HDFFileName, String metaFileName, String updatedFileName);

  //Load library.
  static
  {
    System.loadLibrary("hmu");
  }

  static hmu ahmu;
  JTextArea messageArea;
  JTextField HDFField, METField, UpdatedField;
  Container container;
  JLabel titleLabel, note1Label, note2Label, warn1Label, warn2Label;
  JLabel HDFLabel, METLabel, UpdatedLabel, messageLabel;
  JScrollPane messageAreaScrollPane;
  final JFileChooser fileChooser;
  JButton HDFButton, METButton, updateButton; 
  Dimension areaSize;

  public hmu() 
  {
    super("hmu");
	areaSize=new Dimension(12, 35);

    //Title label.
    titleLabel = new JLabel("HDF-EOS UPDATER"); 

    //Note label.
    note1Label = new JLabel("Select the HDF-EOS file, metadata file"); 
    note2Label = new JLabel("and updated file then click Update button."); 

    //Warn label.
    warn1Label = new JLabel("                                 If updated file is not specified,"); 
    warn2Label = new JLabel("                                   original file will be updated."); 

    //Label.
    HDFLabel= new JLabel("                     HDF-EOS File: ", JLabel.RIGHT);    

    METLabel= new JLabel("                     Metadata File: ", JLabel.RIGHT);    

    UpdatedLabel= new JLabel("Updated File: ", JLabel.RIGHT);    

    //Field.
    HDFField = new JTextField(8);
    METField = new JTextField(8);
    UpdatedField = new JTextField(8);

    //Message label.
    messageLabel= new JLabel("MESSAGE");    
    //messageLabel.setHorizontalAlignment(JLabel.CENTER); 

    //MessageArea.
    messageArea = new JTextArea(10, 30);
    //messageArea.setPreferredSize(areaSize); only this size.
    messageArea.setMargin(new Insets(10, 10, 10, 10));
    messageArea.setEditable(false);
    messageAreaScrollPane = new JScrollPane(messageArea);

    //File chooser
    fileChooser = new JFileChooser();

    //HDF button
    HDFButton = new JButton("Browse");

    //MET button
    METButton = new JButton("Browse");

    //Explicitly set the focus sequence.
    HDFButton.setNextFocusableComponent(METButton);
    METButton.setNextFocusableComponent(HDFButton);

    //Update button.
    updateButton = new JButton("UPDATE"); 

    //GridBag setup
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();

    container=getContentPane();
    container.setLayout(gridbag);
    container.setBackground(Color.white);

    //If image is smaller than area, fill both to full.
    //c.fill = GridBagConstraints.BOTH;
   
    //Components x, y coordinates.
    c.gridx = 0; 
    c.gridy = 0;
      
    //Number of coloum, like: c.gridwidth = 1. Last one=GridBagConstraints.REMAINDER
    c.gridwidth = GridBagConstraints.REMAINDER;
    //Number of row
    c.gridheight= 1;

    //Relate x, y weight between different row. Value from 0 to 1.
    c.weightx = 0;
    c.weighty = 1;
     
    //External up, left, down and right space
    c.insets = new Insets(10, 0, 5, 0);

    //Internal space.
    c.ipady = 0;
    c.ipadx = 0;

    c.gridwidth=1; 
    c.gridheight=1;
    c.weightx=0; 
    c.weighty=0;

    c.gridx = 0; 
    c.gridy = 0;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(titleLabel, c);
    container.add(titleLabel);

    c.insets = new Insets(5, 0, 0, 0);
    c.gridx = 0; 
    c.gridy = 1;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(note1Label, c);
    container.add(note1Label);

    c.insets = new Insets(0, 0, 5, 0);
    c.gridx = 0; 
    c.gridy = 2;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(note2Label, c);
    container.add(note2Label);

    c.ipady = 0;
    c.gridwidth=2;
    c.insets = new Insets(5, 0, 2, 0);
    c.gridx = 0; 
    c.gridy = 3;
    c.anchor = GridBagConstraints.EAST;
    gridbag.setConstraints(HDFLabel, c);
    container.add(HDFLabel);

    c.gridwidth=1;
    c.gridx = 2; 
    c.gridy = 3;
    c.ipady = 6;
    c.weighty = 1;
    c.anchor = GridBagConstraints.CENTER;
    gridbag.setConstraints(HDFField, c);
    container.add(HDFField);

    c.gridwidth=2;
    c.gridx = 3; 
    c.gridy = 3;
    c.ipady = 0;
    c.weighty = 0.5;
    c.anchor = GridBagConstraints.WEST;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(HDFButton, c);
    container.add(HDFButton);

    c.gridwidth=2;
    c.insets = new Insets(2, 0, 2, 0);

    c.gridx = 0; 
    c.gridy = 4;
    c.anchor = GridBagConstraints.EAST;
    gridbag.setConstraints(METLabel, c);
    container.add(METLabel);

    c.gridwidth=1;
    c.gridx = 2; 
    c.gridy = 4;
    c.ipady = 6;
    c.anchor = GridBagConstraints.CENTER;
    gridbag.setConstraints(METField, c);
    container.add(METField);

    c.gridwidth=2;
    c.gridx = 3; 
    c.gridy = 4;
    c.ipady = 0;
    c.anchor = GridBagConstraints.WEST;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(METButton, c);
    container.add(METButton);

    c.insets = new Insets(2, 0, 2, 0);
    c.gridx = 0; 
    c.gridy = 5;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(warn1Label, c);
    container.add(warn1Label);

    c.gridx = 0; 
    c.gridy = 6;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(warn2Label, c);
    container.add(warn2Label);

    c.gridwidth=2;
    c.insets = new Insets(2, 0, 2, 0);

    c.gridx = 0; 
    c.gridy = 7;
    c.anchor = GridBagConstraints.EAST;
    gridbag.setConstraints(UpdatedLabel, c);
    container.add(UpdatedLabel);

    c.gridx = 2; 
    c.gridy = 7;
    c.ipady = 6;
    c.anchor = GridBagConstraints.WEST;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(UpdatedField, c);
    container.add(UpdatedField);

    c.anchor = GridBagConstraints.CENTER;
    c.insets = new Insets(2, 0, 2, 0);
    c.gridx = 0; 
    c.gridy = 8;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(updateButton, c);
    container.add(updateButton);

    c.insets = new Insets(2, 0, 2, 0);
    c.gridx = 0; 
    c.gridy = 9;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(messageLabel, c);
    container.add(messageLabel);

    c.insets = new Insets(2, 20, 20, 20);
    c.gridx = 0; 
    c.gridy = 10;
    c.gridwidth=GridBagConstraints.REMAINDER;
    gridbag.setConstraints(messageAreaScrollPane, c);
    container.add(messageAreaScrollPane);

    /* HEFButton event */
    HDFButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        int returnValue = fileChooser.showOpenDialog(hmu.this);

        if (returnValue == JFileChooser.APPROVE_OPTION) 
        {
          File HDFFile = fileChooser.getSelectedFile();
          String HDFPath = HDFFile.getAbsolutePath();
          HDFField.setText(HDFPath);
          messageArea.setText("Input HDF-EOS file: " + HDFFile.getName() + ".\n");
        } 
        else
        {
          messageArea.setText("No HDF-EOS file is selected.\n");
        }
      }
    });

    /* METButton event */
    METButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        int returnValue = fileChooser.showOpenDialog(hmu.this);

        if (returnValue == JFileChooser.APPROVE_OPTION) 
        {
          File METFile = fileChooser.getSelectedFile();
          String METPath = METFile.getAbsolutePath();
          METField.setText(METPath);
          messageArea.append("Input metadata file: " + METFile.getName() + ".\n");
        } 
        else
        {
          messageArea.setText("No metadata file is selected.\n");
        }
      }
    });

    /* Add update event listener. */
    updateButton.addActionListener(this);
  }  

  /* Update event. */
  public void actionPerformed(ActionEvent e) 
  {
    //Execute native.
    String aString;

    if (HDFField.getText().compareTo("")==0)
    {
      messageArea.setText("No HDF-EOS file input.\n");
    }
    else if (METField.getText().compareTo("")==0)
    {
      messageArea.setText("No metadata file input.\n");
    }
    else
    {
      messageArea.setText("Updating: " + HDFField.getText() + ".\n");
	  messageArea.update(messageArea.getGraphics());
      ahmu.displayhmu(HDFField.getText(), METField.getText(), UpdatedField.getText());
	  messageArea.update(messageArea.getGraphics());
    }
  }
    
  public void showrun(String astring)
  {
    messageArea.append(astring);
    messageArea.update(messageArea.getGraphics());
  }

  public static void main(String[] args) 
  {
    Dimension frameSize=new Dimension(60, 60);
    ahmu = new hmu();

    ahmu.addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        System.exit(0);
      }
    });

    ahmu.setTitle("HDF-EOS Metadata Updater");
    ahmu.setSize(frameSize);
	ahmu.setResizable(false);
    ahmu.pack();
    ahmu.setVisible(true);
  }
}

